#include <WiFi.h>
#include <ArduinoJson.h>
#include <HTTPClient.h>
#include <time.h>
#include <pthread.h>

const int IFPIN = 21;
const int BUZZER = 12;
const int LED = 2;
const char* ssid = "iPhone";
const char* password =  "123456789";

int val = 0;
int isStart = 0;
int isSend = 0;
time_t begin_time = time(NULL);

void sendStatus(){
  StaticJsonDocument<200> doc;
  HTTPClient http;

  http.begin("http://172.20.10.3:3000/status/60659b9b60755d12c79a6982");
  http.addHeader("Content-Type", "application/json");
  if ( !val ){
    doc["status"] = true;
  } else { 
    doc["status"] = false;
  }
  String requestBody;
  serializeJson(doc, requestBody);
  http.POST(requestBody);
  http.end();
}

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  pinMode(IFPIN, INPUT);
  pinMode(LED, OUTPUT);
  ledcSetup(0,1E5,BUZZER);
  ledcAttachPin(25,0);
  WiFi.begin(ssid, password);

  while ( WiFi.status() != WL_CONNECTED ){
    delay(500);
  }
  digitalWrite(LED,HIGH);
}

int checkStatus( int val ){
  if ( !val ){
    if ( !isStart ){
      begin_time = time(NULL);
      isStart = 1;
    } else {
      Serial.println( difftime( time(NULL), begin_time ) );
      if ( difftime( time(NULL), begin_time ) > 30.0 ) {
        return 1;
      }
    }
  } else {
    isStart = 0;
  }
  return 0;
}

void sendLineNoti(){
  HTTPClient http;
  http.begin("http://172.20.10.3:3001/emergency/60659b9b60755d12c79a6982");
  http.POST("notthing");
}

void loop() {
  // put your main code here, to run repeatedly:
  int newVal = digitalRead(IFPIN);

  int buzzer_status = checkStatus(newVal);
  
  if ( buzzer_status ){
    if (!isSend ){
      sendLineNoti();
      isSend = 1;
    }
    ledcWriteTone(0,800);
  } else {
    isSend = 0;
    ledcWriteTone(0,0);
  }
  
  if ( val != newVal ){
    val = newVal;
    sendStatus();
  }
  delay(500);
}
