#include <WiFi.h>
#include <IOXhop_DotMatrix.h>
#include <HTTPClient.h>


#define MAX_DEVICES 4  // number of MAX7219 module

#define DIN_PIN     23 // DIN pin
#define CLK_PIN     18 // CLK pin
#define CS_PIN      5  // CS pin

const char* ssid = "iPhone";
const char* password =  "123456789";
const char* toiletId = "toilet1";
const int LED = 2;

IOXhop_DotMatrix dot(MAX_DEVICES, CS_PIN, DIN_PIN, CLK_PIN);

String getStall(){
  HTTPClient http;
  http.begin("http://172.20.10.3:3000/status/60659914ca2f3c414108d14e");
  http.GET();

  String res = http.getString();
  http.end();
  return res;
}

void setup() {
  pinMode(LED, OUTPUT);
  Serial.begin(115200);
  WiFi.begin(ssid, password);

  while ( WiFi.status() != WL_CONNECTED ){
    delay(500);
  }

  digitalWrite(LED,HIGH);
  dot.begin();
}

void loop() {
  String stall = getStall();
  Serial.println(stall);
  dot.showTextCenter(stall);
  delay(2000);
}
