import React,{useEffect, useState} from "react";
import Accordion from "react-bootstrap/Accordion";
import Card from "react-bootstrap/Card";
import axios from "axios";
import Feedback from "react-bootstrap/esm/Feedback";

interface Toilet  {
  location:String,
  name:String,
  vacant:boolean[]
} 
async function getData(){
  const data = (await axios.get("http://localhost:3000/status")).data
  return data
}


const Toilet_Test : Toilet[] = [{location:"48852",name:"GAMS",vacant:[true,false,true]},{location:"31514",name:"Hell",vacant:[false,false,false]}]

function VacantCount(status:boolean[]){
  let counter = 0;
  for (const elem of status){
    if (elem === true) counter+=1;
  }
  return counter
}

function Vacantdisplay(num:number){
  if (num===0) return true
  else return false
}

function Accordion1() {
  const upDate = async () => {
    const data = await getData();
    setToilet(data)
  }
  //const [toilets,setToilet] = useState<Toilet[]>(Toilet_Test)  use for connect backend
  const [toilets,setToilet] = useState<Toilet[]>(Toilet_Test) //use for Test
  useEffect(()=> {
    setInterval(()=> {
      upDate()
    },2000)
  },[])
  return (
    <div>
      <Accordion defaultActiveKey="0">
        {toilets.map((toilet,index) => {
          return <Card style={{backgroundColor: Vacantdisplay(VacantCount(toilet.vacant)) ? "firebrick":"#145A32"}}>
          <Accordion.Toggle as={Card.Header} eventKey={String(index)} style={{color:"white"}}>
            {toilet.name}
          </Accordion.Toggle>
          <Accordion.Collapse eventKey={String(index)}>

            <Card.Body style={{backgroundColor:"white"}}>
              <p>location : {toilet.location}</p>
              {Vacantdisplay(VacantCount(toilet.vacant)) ? <p style={{color:"red"}}>This toilet is currently full, please wait or checking for another toilet</p>: <p style={{color:"green"}}>{VacantCount(toilet.vacant)} room(s) vacanted</p>}
              {toilet.vacant.map((room,index)=>{
                return room ? <span style={{color:"white",backgroundColor:"green",marginRight:"0.5cm",padding:"0cm 0.5cm"}}> Room {index+1}: Vacant </span> : <span style={{color:"white",backgroundColor:"red",marginRight:"0.5cm",padding:"0cm 0.5cm"}}> Room {index+1}: Occupied </span> 
              })}
            </Card.Body>
          </Accordion.Collapse>
          </Card>
        })}
      </Accordion>
    </div>
  );
}
export default Accordion1;
